
#include <Encoder.h>
#include <LiquidCrystal_I2C.h>
#include <Timer.h>

#define Resolution 5

#define st 1
#define in 2
#define pic 3
#define dis 5

String settings_str[] = { "Shutter         ", "Shutter Time    ", "Interval        ", "Pictures        ", "Confirm?        ", "Display?        "};
    
int genres = 6;
unsigned long int enc_val = 0;
unsigned long int Num[6] = {0,0,0,0,0,0};
unsigned long int temp;
unsigned long int shuttercount = 0;
bool shutterOn = false;
int displaymode = 0;
unsigned long int displayT = 0;
unsigned long int shutterT = 0;

int relaypin = 13;
int knob_sw = 7;


LiquidCrystal_I2C lcd(0x27, 16, 2);
Encoder knob(3,2);
Timer t;


void setup() {

  lcd.begin();
  lcd.backlight();

  pinMode(knob_sw, INPUT);

  pinMode(relaypin, OUTPUT);
  digitalWrite(relaypin, LOW);
  
  //Serial.begin(9600);
  
  t.every(1000,displayPicTaken);
}

void loop() {
  get_enc_val();
  switch(enc_val) 
  {
    case 0:
        lcd.setCursor(0, 0);
        lcd.print(settings_str[enc_val]);
        lcd.setCursor(0, 1);
        lcd.print("Controller      ");
        break;
        
    case 1:                 //shutter time
      print_settings();
      
      if (digitalRead(knob_sw))
      {
        knob.write(0);
        do{}while(digitalRead(knob_sw));
        do
        {
          lcd.setCursor(14, 1);
          lcd.print("<-");
          Num[st] = chooseNum(1);
          
        }while(!digitalRead(knob_sw));
        do{}while(digitalRead(knob_sw));

        knob.write(2*Resolution);
        lcd.setCursor(0, 1);
        lcd.print("                ");
        
      }
        break;
        

      case 2:                 //interval
       print_settings();
      
        if (digitalRead(knob_sw))
        {
          knob.write(0);
          do{}while(digitalRead(knob_sw));
          do
          {
            lcd.setCursor(14, 1);
            lcd.print("<-");
            Num[in] = chooseNum(1);
          
          }while(!digitalRead(knob_sw));
          do{}while(digitalRead(knob_sw));
          
          knob.write(3*Resolution);
          lcd.setCursor(0, 1);
          lcd.print("                ");
        
        }
                  break;

        
      case 3:                 //pictures
        print_settings();
        
        if (digitalRead(knob_sw))
        {
          knob.write(0);
          do{}while(digitalRead(knob_sw));
          do
          {
            lcd.setCursor(14, 1);
            lcd.print("<-");
            Num[pic] = chooseNum(0);
          
          }while(!digitalRead(knob_sw));
          do{}while(digitalRead(knob_sw));
          
          knob.write(4*Resolution);
          lcd.setCursor(0, 1);
          lcd.print("                ");
        
        }
        break;


      case 4:                 //comfirmation
        lcd.setCursor(0, 0);
        lcd.print(settings_str[enc_val]);
        lcd.setCursor(0, 1);
        lcd.print("                ");
        
        if (digitalRead(knob_sw))
        {
          do{}while(digitalRead(knob_sw));
          do
          {
            confirmation();
          }while(!digitalRead(knob_sw));
          //do{}while(digitalRead(knob_sw));

          lcd.setCursor(0, 1);
          lcd.print("**Hold to end**");
          lcd.setCursor(0, 0);
          lcd.print("STARTING        ");
          int j;
          for(j=0;j<8;j++)
          {
            lcd.setCursor(8+j, 0);
            lcd.print(".");
            delay(500);
          }
          
          taking_photos();       
        }
        break;


      case 5:                 //display
        print_settings();
        
        if (digitalRead(knob_sw))
        {
          knob.write(0);
          do{}while(digitalRead(knob_sw));
          do
          {
            lcd.setCursor(14, 1);
            lcd.print("<-");
            Num[dis] = chooseNum(2);
          
          }while(!digitalRead(knob_sw));
          do{}while(digitalRead(knob_sw));
          
          knob.write(4*Resolution);
          lcd.setCursor(0, 1);
          lcd.print("                ");
        
        }
        break;
     
    
  }

  
} 


